/*
 CREDITS :
  
  - This plugin was made by Fractal , all credit goes to him
  - This plugin was ported to AMX Mod X by Peli

 DESCRIPTION :

  - This plugin lets you manage the limits to classes and weapons
    in dod
  - You can type : Amx_limitsmenu in the console to access an easy
    to use menu to manage the classes and weapons
 
 COMMANDS :

  - Admin commands : Amx_limitsmenu - manage classes and weapons
  - Cvars : You can use the cvars in the .cfg but it's easier with
    the menu

 INSTALLATION :

  - Plugin : Download and install the plugin like normal
  - CFG File : You can either :
    - Add an exec server_limits.cfg line in your Server.cfg 
    - Add it in your DoD folder and call make multiple ones
      to make limits for a specific map , but it has to be called :
      mapname_limits.cfg after you edit it manualy
 
 CHANGELOG :
  
  - V.1.1 :
     
  New Class cvars 
  --------------- 
  amx_limitallies_light 
  amx_limitallies_assault  (carbine,thompson,greasegun) 
  amx_limitallies_sniper 
  amx_limitallies_heavy 
  amx_limitallies_mg 

  amx_limitaxis_light    (kar98,k43) 
  amx_limitaxis_assault  (mp40,mp44) 
  amx_limitaxis_sniper   (scopedkar,fg42scoped) 
  amx_limitaxis_heavy 
  amx_limitaxis_mg 

  amx_limitbrit_light 
  amx_limitbrit_assault 
  amx_limitbrit_sniper 
  amx_limitbrit_heavy 
  amx_limitbrit_mg 

  New Weapon cvars (replaces mp_limit....) 
  ---------------- 
  amx_limitallies_garand 
  amx_limitallies_carbine 
  amx_limitallies_thompson 
  amx_limitallies_grease 
  amx_limitallies_spring 
  amx_limitallies_bar 
  amx_limitallies_30cal 

  amx_limitaxis_kar98 
  amx_limitaxis_k43 
  amx_limitaxis_mp40 
  amx_limitaxis_mp44 
  amx_limitaxis_scopedkar 
  amx_limitaxis_fg42bipod 
  amx_limitaxis_fg42scope 
  amx_limitaxis_mg34 
  amx_limitaxis_mg42 

  amx_limitbrit_enfield 
  amx_limitbrit_sten 
  amx_limitbrit_scopedenf
  amx_limitbrit_bren
*/

#include <amxmodx> 

new player_team[33] 
new player_random[33] 
new player_class[33] 
new player_weapon[33] 
new player_status[33] 
new player_autokill[33] 
new player_autokilled[33] 

new classlimit[6][6]   //[team][class] 
new weaponlimit[6][10]   //[team][weapon] 

new classcnt[6][6] 
new weaponcnt[6][10] 

new teamname[6][]  = {"","allies","alliespara","axis","axispara","brit"} 

new classname[6][] = {"","light","assault","sniper","heavy","mg"} 

new light_class[5][]   = {"","garand","kar98","k43","enfield"} 
new assault_class[7][] = {"","carbine","thompson","grease","mp40","mp44","sten"} 
new sniper_class[5][]  = {"","spring","scopedkar","fg42scope","scopedenf"} 
new heavy_class[3][]   = {"","bar","fg42bipod"} 
new mg_class[5][]      = {"","30cal","mg42","mg34","bren"} 

//based on DoD class menus 
new allies_weapon[8][]     = {"","garand","carbine","thompson","grease","spring","bar","30cal"} 
new alliespara_weapon[8][] = {"","garand","carbine","thompson","grease","spring","bar","30cal"} 
new axis_weapon[8][]       = {"","kar98","k43","mp40","mp44","scopedkar","mg34","mg42"} 
new axispara_weapon[10][]  = {"","kar98","k43","mp40","mp44","scopedkar","fg42bipod","fg42scope","mg34","mg42"} 
new brit_weapon[5][]       = {"","enfield","sten","scopedenf","bren"} 

new g_menuteam[33] = 0 


/* Main Menu */ 
public cmdLimitsMenu(id) 
{ 
   if (!(get_user_flags(id) & ADMIN_BAN)) 
      console_print(id,"You have no access to that command") 
   else 
      displayLimitsMenu(id) 

   return PLUGIN_HANDLED 
} 

public displayLimitsMenu(id) 
{ 
   new menuBody[192] 
   format(menuBody,191,"Class Limits Manager^n^n1.  Allies Limits^n2.  Axis Limits^n3.  Brit Limits^n^n9.  Save Server Limits^n0.  Exit") 
   new keys = (1<<0)|(1<<1)|(1<<2)|(1<<8)|(1<<9) 
   show_menu(id,keys,menuBody) 
   return PLUGIN_HANDLED 
} 

public actionLimitsMenu(id,key) 
{ 
   switch(key) 
   { 
      case 0: displayTeamLMenu(id,1)   //allies 
      case 1: displayTeamLMenu(id,3)   //axis 
      case 2: displayTeamLMenu(id,5)   //brit 
      case 8: write_settings(0,0) 
   } 

   return PLUGIN_HANDLED 
} 

/* Team Menus */ 
public displayTeamLMenu(id,tid) 
{ 
   g_menuteam[id] = tid 
   new menuBody[192] 
   format(menuBody,191,"Team Limits - %s^n^n1.  Class Limits^n2.  Weapon Limits^n^n9.  Save Map Limits^n0.  Back",teamname[tid]) 
   new keys = (1<<0)|(1<<1)|(1<<8)|(1<<9) 
   show_menu(id,keys,menuBody) 
   return PLUGIN_HANDLED 
} 

public actionTeamLMenu(id,key) 
{ 
   switch(key) 
   { 
      case 0: displayTeamCMenu(id)   //classes 
      case 1: displayTeamWMenu(id)   //weapons 
      case 8: write_settings(g_menuteam[id],0) 
      case 9: displayLimitsMenu(id) 
   } 

   return PLUGIN_HANDLED 
} 

/* Sub Menus */ 
public displayTeamCMenu(id) 
{ 
   new menuBody[192], limitcvar[32], szValue[3] 
   new keys = 0 
   new b = 0 

   new len = format(menuBody,191,"Team Class Limits - %s^n^n",teamname[ g_menuteam[id] ]) 
   for(new a = 0; a < 5; a++) 
   { 
      keys |= (1<<a) 
      b++    
      format(limitcvar,31,"amx_limit%s_%s",teamname[ g_menuteam[id] ],classname[b]) 
      get_cvar_string(limitcvar,szValue,2) 
      len += format(menuBody[len],191-len,"%d.  %s    %s^n",b,classname[b],szValue) 
   } 
   len += format(menuBody[len],191-len,"^n0.  Back") 
   keys |= (1<<9) 

   show_menu(id,keys,menuBody) 
   return PLUGIN_HANDLED 
} 

public displayTeamWMenu(id) 
{ 
   new menuBody[192], limitcvar[32], szValue[3] 
   new keys = 0 
   new b = 0 
   new maxweap = 0 
   if (g_menuteam[id]==1) 
      maxweap = 7 
   else if (g_menuteam[id]==3) 
      maxweap = 9 
   else if (g_menuteam[id]==5) 
      maxweap = 4 

   new len = format(menuBody,191,"Team Weapon Limits - %s^n^n",teamname[ g_menuteam[id] ]) 
   for(new a = 0; a < maxweap; a++) 
   { 
      keys |= (1<<a) 
      b++    
      if (g_menuteam[id]==1) 
         format(limitcvar,31,"amx_limit%s_%s",teamname[ g_menuteam[id] ],allies_weapon[b]) 
      else if (g_menuteam[id]==3) 
         format(limitcvar,31,"amx_limit%s_%s",teamname[ g_menuteam[id] ],axispara_weapon[b]) 
      else if (g_menuteam[id]==5) 
         format(limitcvar,31,"amx_limit%s_%s",teamname[ g_menuteam[id] ],brit_weapon[b]) 
      get_cvar_string(limitcvar,szValue,2) 
      if (g_menuteam[id]==1) 
         len += format(menuBody[len],191-len,"%d.  %s  %s^n",b,allies_weapon[b],szValue) 
      else if (g_menuteam[id]==3) 
         len += format(menuBody[len],191-len,"%d.  %s  %s^n",b,axispara_weapon[b],szValue) 
      else if (g_menuteam[id]==5) 
         len += format(menuBody[len],191-len,"%d.  %s  %s^n",b,brit_weapon[b],szValue) 
   } 
   len += format(menuBody[len],191-len,"^n0.  Back") 
   keys |= (1<<9) 

   show_menu(id,keys,menuBody) 
   return PLUGIN_HANDLED 
} 

public actionTeamCMenu(id,key) 
{ 
   switch(key) 
   { 
      case 8: write_settings(g_menuteam[id],1) 
      case 9: displayTeamLMenu(id,g_menuteam[id]) 
      default: 
      { 
         new limitcvar[32], szValue[3], newval[3] 
         format(limitcvar,31,"amx_limit%s_%s",teamname[g_menuteam[id]],classname[key+1]) 
         get_cvar_string(limitcvar,szValue,2) 
         new val = str_to_num(szValue) 
         if(++val > 16) 
            val = -1 
         num_to_str(val,newval,2) 
         classlimit[g_menuteam[id]][key+1] = val 
         if (g_menuteam[id]==1 || g_menuteam[id]==3)   //para 
            classlimit[g_menuteam[id]+1][key+1] = val 
         set_cvar_string(limitcvar,newval) 
         displayTeamCMenu(id) 
      }      
   } 
   return PLUGIN_HANDLED 
} 

public actionTeamWMenu(id,key) 
{ 
   switch(key) 
   { 
      case 8: write_settings(g_menuteam[id],2) 
      case 9: displayTeamLMenu(id,g_menuteam[id]) 
      default: 
      { 
         new limitcvar[32], szValue[3], newval[3] 
         if (g_menuteam[id]==1) 
            format(limitcvar,31,"amx_limit%s_%s",teamname[ g_menuteam[id] ],allies_weapon[key+1]) 
         else if (g_menuteam[id]==3) 
            format(limitcvar,31,"amx_limit%s_%s",teamname[ g_menuteam[id] ],axispara_weapon[key+1]) 
         else if (g_menuteam[id]==5) 
            format(limitcvar,31,"amx_limit%s_%s",teamname[ g_menuteam[id] ],brit_weapon[key+1]) 
         get_cvar_string(limitcvar,szValue,2) 
         new val = str_to_num(szValue) 
         if(++val > 16) 
            val = -1 
         num_to_str(val,newval,2) 
         weaponlimit[g_menuteam[id]][key+1] = val 
         if (g_menuteam[id]==1 || g_menuteam[id]==3)   //para 
            weaponlimit[g_menuteam[id]+1][key+1] = val 
         set_cvar_string(limitcvar,newval) 
         displayTeamWMenu(id) 
      }      
   } 
   return PLUGIN_HANDLED 
} 


/* intercept class menu */ 
public check_class_menu(id) 
{ 
   new arg = read_data(1) 
   new teamid 
   if (arg==9) 
      teamid = 1 
   else if (arg==21) 
      teamid = 2 
   else if (arg==10) 
      teamid = 3 
   else if (arg==22) 
      teamid = 4 
   else if (arg==26) 
      teamid = 5 

   //just joined a team 
   if (!player_team[id]) 
   { 
      player_team[id] = teamid 
      return PLUGIN_CONTINUE 
   } 

   //switched teams 
   if (player_team[id]!=teamid) 
   { 
      player_team[id] = teamid 
      player_random[id] = 0 
      player_class[id] = 0 
      player_weapon[id] = 0 
      player_status[id] = 0 
      player_autokilled[id] = 0 
   } 

   //chose random or a limited class 
   if(player_status[id]==1 || player_status[id]==2) 
   { 
      new command[32] 
      if(player_status[id]==1)   //chose random 
      { 
         player_weapon[id] = get_random_selection(id) 
         format(command,31,"slot%d",player_weapon[id] + 1) 
         client_cmd(id,command) 
      } 
      else if(!player_weapon[id])   //no prior class to put back in
      { 
         client_print(id,print_chat," NO SLOTS AVAILABLE, SELECTING A RANDOM CLASS") 
         player_status[id] = 1
         player_weapon[id] = get_random_selection(id) 
         format(command,31,"slot%d",player_weapon[id] + 1) 
         client_cmd(id,command) 
      } 
      else
      { 
         //put them back in the class they were in and bring up class menu again 
         client_print(id,print_chat," NO SLOTS AVAILABLE FOR THAT CLASS") 
         player_status[id] = 3 
         format(command,31,"slot%d",player_weapon[id] + 1) 
         client_cmd(id,command) 
      } 
   } 

   return PLUGIN_CONTINUE 
} 

/* player has chosen a class, check that it is ok*/ 
public log_class_change() 
{ 
   new player[64] 
   read_logargv(0,player,63) 

   new name[32], userid, authid[32], logteam[11] 
   parse_loguser(player,name,31,userid,authid,31,logteam,10) 
   new id = get_user_index(name) 

   new log_classname[64] 
   read_logargv(2,log_classname,63) 

   //fix names (see titles.txt) 
   replace(log_classname,63,"_allied_sniper","_allied_spring") 
   replace(log_classname,63,"_allied_heavy","_allied_bar") 
   replace(log_classname,63,"_allied_mg","_allied_30cal") 
   replace(log_classname,63,"_axis_sniper","_axis_scopedkar") 
   replace(log_classname,63,"_brit_light","_brit_enfield") 
   replace(log_classname,63,"_brit_medium","_brit_sten") 
   replace(log_classname,63,"_brit_sniper","_brit_scopedenf") 
   replace(log_classname,63,"_brit_heavy","_brit_bren") 

   //if they pick random, make our own random selection (because the default random ignores class limits) 
   if (equali(log_classname, "random")) 
   { 
      player_random[id] = 1 
      player_status[id] = 1 
      client_cmd(id,"changeclass") 
      return PLUGIN_CONTINUE 
   } 

   new classid = get_classid(log_classname) 
   new weaponid = get_weaponid(player_team[id],log_classname) 

   //class was full so start over 
   if(player_status[id]==3) 
      player_status[id]=0 
   //check if class is limited 
   else if((classlimit[player_team[id]][classid] == -1 || classcnt[player_team[id]][classid] < classlimit[player_team[id]][classid]) && 
      (weaponlimit[player_team[id]][weaponid] == -1 || weaponcnt[player_team[id]][weaponid] < weaponlimit[player_team[id]][weaponid])) 
   { 
      if (is_user_alive(id) && player_autokill[id] && classid!=player_class[id]) 
      {
         player_autokilled[id] = 1
         user_kill(id,1) 
      }
      //remove from old class 
      if (player_class[id]) 
      { 
         classcnt[player_team[id]][player_class[id]]-- 
         weaponcnt[player_team[id]][player_weapon[id]]-- 
      } 
      //add to new class 
      player_class[id]=classid 
      player_weapon[id]=weaponid 
      classcnt[player_team[id]][classid]++ 
      weaponcnt[player_team[id]][weaponid]++ 
      //not in random mode anymore
      if (player_status[id]!=1) 
         player_random[id] = 0
      player_status[id] = 0 
   } 
   else 
   { 
      //still in random mode (haven't found a non-limited weapon yet) 
      if (player_status[id]==1) 
         client_cmd(id,"changeclass") 
      else 
      //class was full 
      { 
         player_status[id] = 2 
         client_cmd(id,"changeclass") 
      } 
   } 

   return PLUGIN_CONTINUE 
} 

/* auto select a new random weapon on death */ 
public log_kill()
{
   new victim[64] 
   read_logargv(2,victim,63) 
   new name[32], userid, authid[32], v_team[12] 
   parse_loguser(victim,name,31,userid,authid,31,v_team,11) 
   new id = get_user_index(name) 

   if (player_random[id]) 
   { 
      player_status[id] = 1 
      client_cmd(id,"changeclass") 
   } 
   return PLUGIN_CONTINUE 
}

public log_suicide()
{
   new victim[64] 
   read_logargv(0,victim,63) 
   new name[32], userid, authid[32], v_team[12] 
   parse_loguser(victim,name,31,userid,authid,31,v_team,11) 
   new id = get_user_index(name) 

   if (player_autokilled[id])
      return PLUGIN_CONTINUE 

   if (player_random[id] && player_status[id]==0) 
   { 
      player_status[id] = 1 
      client_cmd(id,"changeclass") 
   } 
   return PLUGIN_CONTINUE 
}

public respawn_msg(id)
{
   player_autokilled[id] = 0
   return PLUGIN_CONTINUE 
}

/* get a random weapon */ 
get_random_selection(id) 
{ 
   //current weapon counts per team as of v1.0 
   new maxweap 
   if(player_team[id]==1) 
      maxweap = 7 
   else if(player_team[id]==2) 
      maxweap = 7 
   else if(player_team[id]==3) 
      maxweap = 7 
   else if(player_team[id]==4) 
      maxweap = 9 
   else if(player_team[id]==5) 
      maxweap = 4 

   //find an non-limited random weapon 
   new a, rw = 0, wname[32], cid 
   while(rw==0) 
   { 
      a = random_num(1,maxweap) 
      if(weaponlimit[player_team[id]][a] == -1 || weaponcnt[player_team[id]][a] < weaponlimit[player_team[id]][a]) 
      { 
         get_weapon(player_team[id], a, wname) 
         cid = get_classid(wname) 
         if(classlimit[player_team[id]][cid] == -1 || classcnt[player_team[id]][cid] < classlimit[player_team[id]][cid]) 
            if (a != player_weapon[id])
               rw = a
      } 
   } 

   return rw
} 

/* get weaponname of weaponid/teamid combo */ 
get_weapon(tid,wid,weaponname[]) 
{ 
   if(tid==1 && wid < 8) 
   { 
      format(weaponname,31,allies_weapon[wid]) 
      return 1 
   } 
   else if(tid==2 && wid < 8) 
   { 
      format(weaponname,31,alliespara_weapon[wid]) 
      return 1 
   } 
   else if(tid==3 && wid < 8) 
   { 
      format(weaponname,31,axis_weapon[wid]) 
      return 1 
   } 
   else if(tid==4 && wid < 10) 
   { 
      format(weaponname,31,axispara_weapon[wid]) 
      return 1 
   } 
   else if(tid==5 && wid < 5) 
   { 
      format(weaponname,31,brit_weapon[wid]) 
      return 1 
   } 

   return 0 
} 

/* get class id */ 
get_classid(cname[]) 
{ 

   new i 
   for(i = 1; i < 5; i++) 
      if (containi(cname,light_class[i])!=-1) 
         return 1 
    
   for(i = 1; i < 7; i++) 
      if (containi(cname,assault_class[i])!=-1) 
         return 2 

   for(i = 1; i < 5; i++) 
      if (containi(cname,sniper_class[i])!=-1) 
         return 3 

   for(i = 1; i < 3; i++) 
      if (containi(cname,heavy_class[i])!=-1) 
         return 4 

   for(i = 1; i < 5; i++) 
      if (containi(cname,mg_class[i])!=-1) 
         return 5 

   return 0 
} 

/* get weapon id */ 
get_weaponid(tid,wname[]) 
{ 
   new i 
   if(tid==1) 
      for(i = 1; i < 8; i++) 
         if (containi(wname,allies_weapon[i])!=-1) 
            return i 
   if(tid==2) 
      for(i = 1; i < 8; i++) 
         if (containi(wname,alliespara_weapon[i])!=-1) 
            return i 
   if(tid==3) 
      for(i = 1; i < 8; i++) 
         if (containi(wname,axis_weapon[i])!=-1) 
            return i 
   if(tid==4) 
      for(i = 1; i < 10; i++) 
         if (containi(wname,axispara_weapon[i])!=-1) 
            return i 
   if(tid==5) 
      for(i = 1; i < 5; i++) 
         if (containi(wname,brit_weapon[i])!=-1) 
            return i 

   return 0 
} 

/* load cvar settings */ 
public load_settings() 
{ 
   //DoD default cvars (not used by this plugin, but need to "turn off" so DoD won't use them) 
   //we do this here to ensure they are cleared AFTER map configs load 
   set_cvar_string("mp_limitalliesgarand","-1") 
   set_cvar_string("mp_limitalliescarbine","-1") 
   set_cvar_string("mp_limitalliesthompson","-1") 
   set_cvar_string("mp_limitalliesgrease","-1") 
   set_cvar_string("mp_limitalliesspring","-1") 
   set_cvar_string("mp_limitalliesbar","-1") 
   set_cvar_string("mp_limitallies30cal","-1") 
   set_cvar_string("mp_limitaxiskar","-1") 
   set_cvar_string("mp_limitaxisk43","-1") 
   set_cvar_string("mp_limitaxisscopedkar","-1") 
   set_cvar_string("mp_limitaxismp40","-1") 
   set_cvar_string("mp_limitaxismp44","-1") 
   set_cvar_string("mp_limitaxismg34","-1") 
   set_cvar_string("mp_limitaxismg42","-1") 
   set_cvar_string("mp_limitaxisfg42","-1") 
   set_cvar_string("mp_limitaxisfg42s","-1") 
   set_cvar_string("mp_limitbritlight","-1") 
   set_cvar_string("mp_limitbritassault","-1") 
   set_cvar_string("mp_limitbritsniper","-1") 
   set_cvar_string("mp_limitbritmg","-1") 

   new i, j, limitcvar[32], weapon[32], classteam[32] 

   //class limits 
   for(i = 1; i < 6; i++) 
   { 
      for(j = 1; j < 6; j++) 
      { 
         classcnt[i][j] = 0 
         if(i==2 || i==4)   //para 
            classlimit[i][j] = classlimit[i-1][j] 
         else 
         { 
            format(limitcvar,31,"amx_limit%s_%s",teamname[i],classname[j]) 
            classlimit[i][j] = get_cvar_num(limitcvar) 
         } 
      } 
   } 

   //weapon limits 
   for(i = 1; i < 6; i++) 
   { 
      for(j = 1; j < 10; j++) 
      { 
         weaponcnt[i][j] = 0 
         if(get_weapon(i, j, weapon)) 
         { 
            //make para limits same as normal... 
            if(i==2 || (i==4 && j<6)) 
               weaponlimit[i][j] = weaponlimit[i-1][j] 
            else 
            if(i==4 && (j==8 || j==9)) 
               weaponlimit[i][j] = weaponlimit[i-1][j-2] 
            else 
            { 
               copy(classteam,31,teamname[i]) 
               replace(classteam,31,"axispara","axis")   //for fg42 
               format(limitcvar,31,"amx_limit%s_%s",classteam,weapon) 
               weaponlimit[i][j] = get_cvar_num(limitcvar) 
            } 
         } 
         else 
            weaponlimit[i][j] = 0 
      } 
   } 

} 

/* save cvar settings */ 
public write_settings(tid,type) 
{ 
   new maplimits_file[32] 
   if (tid==0 && type==0) 
      format(maplimits_file,31,"server_limits.cfg") 
   else 
   { 
      new currmap[32] 
      get_mapname(currmap,31) 
      format(maplimits_file,31,"%s_limits.cfg",currmap) 
   } 

   if (!file_exists(maplimits_file)) 
      write_file(maplimits_file,"") 

   new i, j, x, limitcvar[32], weapon[32], data[32] 
   new text[80], cvar[32], val[3] 
   new a, pos, found 

   //class limits 
   if (type==1 || type==0) 
   { 
      for(i = 1; i < 6; i++) 
      { 
         if (i==1 || i==3 || i==5) 
         { 
            if (i==tid || tid==0) 
            { 
               for(j = 1; j < 6; j++) 
               { 
                  format(limitcvar,31,"amx_limit%s_%s",teamname[i],classname[j]) 
                  format(data,31,"%s %i",limitcvar,classlimit[i][j]) 
                  a = pos = found = 0 
                  while (read_file(maplimits_file,pos++,text,79,a)) 
                  {          
                     if (text[0] == ';') 
                        continue 
                     if (parse(text,cvar,31,val,2) != 2) 
                        continue 
                     if (equali(cvar,limitcvar)) 
                     { 
                        found = 1 
                        write_file(maplimits_file,data,pos-1) 
                        break 
                     } 
                  } 
                  if (!found) 
                     write_file(maplimits_file,data) 
               } 
            } 
         } 
      } 
   } 

   //weapon limits 
   if (type==2 || type==0) 
   { 
      for(i = 1; i < 6; i++) 
      { 
         if (i==1 || i==3 || i==5) 
         { 
            if (i==tid || tid==0) 
            { 
               for(j = 1; j < 10; j++) 
               { 
                  if (i==3)   //include para weapons (fg42) 
                     x = i + 1 
                  else 
                     x = i 
                  if (get_weapon(x,j,weapon)) 
                  { 
                     format(limitcvar,31,"amx_limit%s_%s",teamname[i],weapon) 
                     format(data,31,"%s %i",limitcvar,weaponlimit[x][j]) 
                     a = pos = found = 0 
                     while (read_file(maplimits_file,pos++,text,79,a)) 
                     {          
                        if (text[0] == ';') 
                           continue 
                        if (parse(text,cvar,31,val,2) < 2) 
                           continue 
                        if (equali(cvar,limitcvar)) 
                        { 
                           found = 1 
                           write_file(maplimits_file,data,pos-1) 
                           break 
                        } 
                     } 
                     if (!found) 
                        write_file(maplimits_file,data) 
                  } 
               } 
            } 
         } 
      } 
   } 

} 

/* initialize player */ 
public client_connect(id) 
{ 
   player_team[id] = 0 
   player_random[id] = 0 
   player_class[id] = 0 
   player_weapon[id] = 0 
   player_status[id] = 0 
   player_autokill[id] = 0 
   player_autokilled[id] = 0 

   return PLUGIN_CONTINUE 
} 

/* set player's autokill status */ 
public client_putinserver(id) 
{ 
   new param[3] 
   param[0] = id 
   set_task(0.9,"set_autokill",0,param,2) 

   return PLUGIN_CONTINUE 
} 

public set_autokill(param[]) 
{ 
   new id = param[0] 
   new temp[2] 
   get_user_info(id,"hud_classautokill",temp,1) 
   player_autokill[id] = str_to_num(temp) 
   if (player_autokill[id]) 
      client_cmd(id,"hud_classautokill 0") 
} 

/* remove player from limit counts */ 
public client_disconnect(id) 
{ 
   if (player_team[id] && player_class[id]) 
   { 
      classcnt[player_team[id]][player_class[id]]-- 
      weaponcnt[player_team[id]][player_weapon[id]]-- 
   } 

   return PLUGIN_CONTINUE 
} 

public plugin_init() 
{ 
   register_plugin("DoD Limits Manager","0.9.4","Fractal") 

   register_event("VGUIMenu","check_class_menu","b","1=9","1=10","1=21","1=22","1=26") 
   register_logevent("log_class_change",3,"1=changed role to") 
   register_logevent("log_kill",5,"1=killed")
   register_logevent("log_suicide",3,"1=committed suicide with")
   register_logevent("log_suicide",4,"1=committed suicide with")
   register_event("ResetHUD", "respawn_msg","b")

   //menus 
   register_clcmd("amx_limitsmenu","cmdLimitsMenu",ADMIN_BAN,"- display limits menu") 
   register_menucmd(register_menuid("Team Class Limits"),1023,"actionTeamCMenu") 
   register_menucmd(register_menuid("Team Weapon Limits"),1023,"actionTeamWMenu") 
   register_menucmd(register_menuid("Team Limits"),1023,"actionTeamLMenu") 
   register_menucmd(register_menuid("Class Limits Manager"),1023,"actionLimitsMenu") 

   //classes 
   register_cvar("amx_limitallies_light","-1") 
   register_cvar("amx_limitallies_assault","-1") 
   register_cvar("amx_limitallies_sniper","-1") 
   register_cvar("amx_limitallies_heavy","-1") 
   register_cvar("amx_limitallies_mg","-1") 

   register_cvar("amx_limitaxis_light","-1") 
   register_cvar("amx_limitaxis_assault","-1") 
   register_cvar("amx_limitaxis_sniper","-1") 
   register_cvar("amx_limitaxis_heavy","-1") 
   register_cvar("amx_limitaxis_mg","-1") 

   register_cvar("amx_limitbrit_light","-1") 
   register_cvar("amx_limitbrit_assault","-1") 
   register_cvar("amx_limitbrit_sniper","-1") 
   register_cvar("amx_limitbrit_heavy","-1")   //brit heavy is basically mg and visa versa 
   register_cvar("amx_limitbrit_mg","-1") 

   //weapons 
   register_cvar("amx_limitallies_garand","-1") 
   register_cvar("amx_limitallies_carbine","-1") 
   register_cvar("amx_limitallies_thompson","-1") 
   register_cvar("amx_limitallies_grease","-1") 
   register_cvar("amx_limitallies_spring","-1") 
   register_cvar("amx_limitallies_bar","-1") 
   register_cvar("amx_limitallies_30cal","-1") 

   register_cvar("amx_limitaxis_kar98","-1") 
   register_cvar("amx_limitaxis_k43","-1") 
   register_cvar("amx_limitaxis_scopedkar","-1") 
   register_cvar("amx_limitaxis_mp40","-1") 
   register_cvar("amx_limitaxis_mp44","-1") 
   register_cvar("amx_limitaxis_fg42bipod","-1") 
   register_cvar("amx_limitaxis_fg42scope","-1") 
   register_cvar("amx_limitaxis_mg34","-1") 
   register_cvar("amx_limitaxis_mg42","-1") 

   register_cvar("amx_limitbrit_enfield","-1") 
   register_cvar("amx_limitbrit_sten","-1") 
   register_cvar("amx_limitbrit_scopedenf","-1") 
   register_cvar("amx_limitbrit_bren","-1") 

   if (file_exists("server_limits.cfg")) 
      server_cmd("exec server_limits.cfg") 
   new currmap[32] 
   get_mapname(currmap,31) 
   new maplimits_file[32] 
   format(maplimits_file,31,"%s_limits.cfg",currmap) 
   if (file_exists(maplimits_file)) 
      server_cmd("exec %s",maplimits_file) 

   set_task(0.6,"load_settings") 

   return PLUGIN_CONTINUE 
} 


